#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdlib.h>

#define LED_ON()    (PORTB |= 1<<PB0)
#define LED_OFF()   (PORTB &= ~(1<<PB0))

int main(void)
{
    // Make the LED an output
    DDRB |= 1<<PB0;
        
    // Enable timer
    TCCR0B |= (1 << CS01);
    TIMSK0 |= (1 << OCIE0A) | (1 << TOIE0);

    int max = 100, min = 50;
    OCR0A = min;

    // Turn on global interrupts        
    sei();

    int up = 1;
    while(1)
    {
        if (up) {
            if (++OCR0A == max)
                up = 0;
        } else {
            if (--OCR0A == min)
                up = 1;
        }
        _delay_ms(20);
    }

}

ISR(TIM0_OVF_vect)
{
    LED_ON();
}

ISR(TIM0_COMPA_vect)
{
    LED_OFF();
}